#include <bits/stdc++.h>

using namespace std;

#define MAXN 1000010
#define MOD 1000000007

long long n;
long long x[MAXN];
long long y[MAXN];

int main()
{
    cin>>n;
    for (long long i=1;i<=n;i++) cin>>x[i]>>y[i];
    long long xmin=x[1];
    long long xmax=x[1];
    long long ymin=y[1];
    long long ymax=y[1];
    for (long long i=1;i<=n;i++)
    {
        if (i==1) cout<<0<<endl;
        else
        {
            if (x[i]<xmin) xmin=x[i];
            if (x[i]>xmax) xmax=x[i];
            if (y[i]<ymin) ymin=y[i];
            if (y[i]>ymax) ymax=y[i];
            long long br1=0;
            long long br2=0;
            long long br3=0;
            long long br4=0;
            //cout<<x[i]<<" "<<y[i]<<endl;
            //cout<<xmin<<" "<<xmax<<" "<<ymin<<" "<<ymax<<endl;
            for (long long j=1;j<=i;j++)
            {
                br1+=abs(x[j]-xmin)*abs(y[j]-ymin);
                if (br1>=MOD) br1%=MOD;
                br2+=abs(x[j]-xmax)*abs(y[j]-ymin);
                if (br2>=MOD) br2%=MOD;
                br3+=abs(x[j]-xmin)*abs(y[j]-ymax);
                if (br3>=MOD) br3%=MOD;
                br4+=abs(x[j]-xmax)*abs(y[j]-ymax);
                if (br4>=MOD) br4%=MOD;
            }
            cout<<max(max(max(br1,br2),br3),br4)<<endl;
            //cout<<br1<<" "<<br2<<" "<<br3<<" "<<br4<<endl;
        }
    }
}